package warehouse.management;
import java.util.HashMap;
import java.util.Collection;
import java.util.Set;

public class Warehouse {
	private HashMap<String,Shelf> shelfs = new HashMap<String,Shelf>();
	public void receive(Product prod, String loc) {
		if(shelfs.containsKey(loc)){
			shelfs.get(loc).add(prod);
			return;
		}
		Shelf s = new Shelf();
		s.add(prod);
		shelfs.put(loc, s);
	}
	public int getItemCount(Product prod){
		Collection<Shelf> list = shelfs.values();
		int counter = 0;
		for(Shelf s : list){
			counter += s.getItemCount(prod);
		}
		return counter;
	}
	public String dispatch(Product prod){
		Set<String> set = shelfs.keySet();
		for(String s: set){
			System.out.println(s);
			Shelf t = shelfs.get(s);
			if(t.dispatch(prod)){
				return s;
			}
		}
		return null;
	}
	@Override
	public String toString(){
		String res = "\n\n *** LADU ***";
		Set<String> set = shelfs.keySet();
		for(String s: set){
			Shelf t = shelfs.get(s);
			res += "\nRiiul "+s + t;
		}
		return res;
	}
}
